const ContractArchive = {
    route : 'contract/archive/:groupId',
    templateUrl : 'js/app/views/contract/contract-archive.html',
    navigatioData : null,
    redirectUrl : 'auth/login',

    canAccess : function()
    {
        return this.app.user.isLoggedIn();
    },

    create : function( p )
    {
        this.container = this.app.UI.getContentContainer();
        self.contracts = [];
        const $container = $( this.container ),
            app = this.app,
            groupId = p.get( 'groupId' ),
            members = [],
            apps = [];

        this.render();

        this.app.rpc.call(
            'Contract',
            'getList',
            {
                teamId : groupId,
                state : 'archive'
            },
            function( res )
            {
                if ( res && res.hasOwnProperty( 'data' ) && res.data.hasOwnProperty( 'contractData' ) )
                {
                    const cs = res.data.contractData;
                    self.contracts = [];
                    for( let ci = 0; ci < cs.length; ci++ )
                    {
                        self.contracts.push( this.createInstance( 'Contract', cs[ ci ] ) );
                    }
                }

                let compDt = this.createComponent(
                    'contract-data-table',
                    $container.find( '[f-id="container-contract-data-table"]' ).first().get( 0 ),
                    {
                        contracts : self.contracts,
                        groupId : groupId,
                        filter : 'archive'
                    }
                );
                $container.find( '.sk-loading' ).toggleClass( 'sk-loading' );


                compDt.addEventListener( 'singleContractReactivation', function( e )
                {
                    let contractId = e.data.contractId;

                    let $modalRoot = $container.find( '[data-id="modal-confirm-single-reactivation"]' ).first();
                    $modalRoot.find( '[data-id="section-single-reactivation-confirmation"]' ).first().show();
                    $modalRoot.find( '[data-id="section-loader"]' ).first().hide();
                    $modalRoot.on( 'shown.bs.modal', function()
                    {
                        $modalRoot.find( '[data-id="btnReactivate"]' ).first().off( "click" );
                        $modalRoot.find( '[data-id="btnReactivate"]' ).first().click( function()
                        {
                            $(this).off( "click" );

                            $modalRoot.find( '[data-id="section-single-reactivation-confirmation"]' ).first().hide();
                            $modalRoot.find( '[data-id="section-loader"]' ).first().show();

                            app.rpc.call(
                                'Contract',
                                'batchReactivate',
                                {
                                    contractIds : [ contractId ]
                                },
                                function( resp )
                                {
                                    if ( resp && resp.hasOwnProperty( 'code' ) && resp.code == 200 )
                                    {
                                        app.UI.toastSuccess( 'Vertrag erfolgreich reaktiviert.' );
                                        app.reload();
                                    }
                                    else
                                    {
                                        app.UI.toastError();
                                    }
                                    $modalRoot.modal( 'hide' );
                                }
                            );
                        });
                    });
                    $modalRoot.on( 'hidden.bs.modal', function()
                    {
                        $modalRoot.modal( 'dispose' );
                    });
                    $modalRoot.modal( 'show' );
                });

                compDt.addEventListener( 'singleContractDeletion', function( e )
                {
                    let contractId = e.data.contractId;

                    let $modalRoot = $container.find( '[data-id="modal-confirm-single-delete"]' ).first();
                    $modalRoot.find( '[data-id="section-single-delete-confirmation"]' ).first().show();
                    $modalRoot.find( '[data-id="section-loader"]' ).first().hide();
                    $modalRoot.on( 'shown.bs.modal', function()
                    {
                        $modalRoot.find( '[data-id="btnDeleteContract"]' ).first().off( "click" );
                        $modalRoot.find( '[data-id="btnDeleteContract"]' ).first().click( function()
                        {
                            $(this).off( "click" );

                            $modalRoot.find( '[data-id="section-single-delete-confirmation"]' ).first().hide();
                            $modalRoot.find( '[data-id="section-loader"]' ).first().show();

                            app.rpc.call(
                                'Contract',
                                'batchDelete',
                                {
                                    contractIds : [ contractId ]
                                },
                                function( resp )
                                {
                                    if ( resp && resp.hasOwnProperty( 'code' ) && resp.code == 200 )
                                    {
                                        app.UI.toastSuccess( 'Vertrag erfolgreich gelöscht.' );
                                        app.reload();
                                    }
                                    else
                                    {
                                        app.UI.toastError();
                                    }
                                    $modalRoot.modal( 'hide' );
                                }
                            );
                        });
                    });
                    $modalRoot.on( 'hidden.bs.modal', function()
                    {
                        $modalRoot.modal( 'dispose' );
                    });
                    $modalRoot.modal( 'show' );
                });


                $container.find( '[data-id="btnReactivateContracts"]').first().click( function()
                {
                    let contractIds = compDt.getSelectedIds();
                    if ( 0 === contractIds.length )
                    {
                        app.UI.toastError( 'Bitte wählen Sie die Verträge aus, die Sie reaktivieren möchten.', 'Keine Verträge ausgewählt.' );
                        return false;
                    }

                    let $modalRoot = $container.find( '[data-id="modal-confirm-multiple-reactivation"]' ).first();
                    $modalRoot.find( '[data-id="section-single-reactivation-confirmation"]' ).first().show();
                    $modalRoot.find( '[data-id="section-loader"]' ).first().hide();
                    $modalRoot.on( 'shown.bs.modal', function()
                    {
                        $modalRoot.find( '[data-id="btnReactivate"]' ).first().off( "click" );
                        $modalRoot.find( '[data-id="btnReactivate"]' ).first().click( function()
                        {
                            $(this).off( "click" );

                            $modalRoot.find( '[data-id="section-single-reactivation-confirmation"]' ).first().hide();
                            $modalRoot.find( '[data-id="section-loader"]' ).first().show();

                            app.rpc.call(
                                'Contract',
                                'batchReactivate',
                                {
                                    contractIds : contractIds
                                },
                                function( resp )
                                {
                                    if ( resp && resp.hasOwnProperty( 'code' ) && resp.code == 200 )
                                    {
                                        app.UI.toastSuccess( 'Verträge erfolgreich reaktiviert.' );
                                        app.reload();
                                    }
                                    else
                                    {
                                        app.UI.toastError();
                                    }
                                    $modalRoot.modal( 'hide' );
                                }
                            );
                        });
                    });
                    $modalRoot.on( 'hidden.bs.modal', function()
                    {
                        $modalRoot.modal( 'dispose' );
                    });
                    $modalRoot.modal( 'show' );

                });

                $container.find( '[data-id="btnDeleteContracts"]').first().click( function()
                {
                    let contractIds = compDt.getSelectedIds();
                    if ( 0 === contractIds.length )
                    {
                        app.UI.toastError( 'Bitte wählen Sie die Verträge aus, die Sie löschen möchten.', 'Keine Verträge ausgewählt.' );
                        return false;
                    }

                    let $modalRoot = $container.find( '[data-id="modal-confirm-multiple-delete"]' ).first();
                    $modalRoot.find( '[data-id="section-single-delete-confirmation"]' ).first().show();
                    $modalRoot.find( '[data-id="section-loader"]' ).first().hide();
                    $modalRoot.on( 'shown.bs.modal', function()
                    {
                        $modalRoot.find( '[data-id="btnDeleteContract"]' ).first().off( "click" );
                        $modalRoot.find( '[data-id="btnDeleteContract"]' ).first().click( function()
                        {
                            $(this).off( "click" );

                            $modalRoot.find( '[data-id="section-single-delete-confirmation"]' ).first().hide();
                            $modalRoot.find( '[data-id="section-loader"]' ).first().show();

                            app.rpc.call(
                                'Contract',
                                'batchDelete',
                                {
                                    contractIds : contractIds
                                },
                                function( resp )
                                {
                                    if ( resp && resp.hasOwnProperty( 'code' ) && resp.code == 200 )
                                    {
                                        app.UI.toastSuccess( 'Verträge erfolgreich gelöscht.' );
                                        app.reload();
                                    }
                                    else
                                    {
                                        app.UI.toastError();
                                    }
                                    $modalRoot.modal( 'hide' );
                                }
                            );
                        });
                    });
                    $modalRoot.on( 'hidden.bs.modal', function()
                    {
                        $modalRoot.modal( 'dispose' );
                    });
                    $modalRoot.modal( 'show' );
                });

            }.bind ( this )
        );
    },

    destroy : function()
    {

    }
};

export { ContractArchive };